<?php
/**
* @package NeoLatestNews
* @copyright Copyright (C) 2004 - 2009 Neoweb. All rights reserved.
* @license GNU/GPL
* @version 1.4.1
* @author NeoJoomla
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once( JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php' );

class modNeoLatestNewsHelper {
	
	/* **** Private vars  **** */
	var $params;
	var $content_source;
	var $sectionid;
	var $catid;
	var $style_sfx;
	
	// Parameters from articles
	var $intro;
	var $leading;
	var $links;
	var $column;
	var $ordering;
	var $access_mode;
	var $allnews;
	var $show_seperator;
	var $usefront;
	
	// Details
	var $show_title;
	var $link_title;
	var $show_cat;
	var $show_author;
	var $show_intro;
	var $intro_length;	
	var $open_mode;
	var $catlink;
	var $show_readmore;
	
	// Parameters from date
	var $show_date;
	var $formatdate;
	
	// Parameters from images
	var $show_images;	
	var $images_size;
	var $images_position;
	var $images_maxwidth;
	var $images_maxheight;
	
	var $rand_items;
	

	/* **** Public methods  **** */
	
	function init( &$parameters ) {
		
		$params = $parameters;
		
		$this->content_source 	= $params->get( 'content_source' );
		$this->sectionids		= $params->get( 'sectionids' );		
		$this->catids			= $params->get( 'catids' );
		
		if ( $this->sectionids && !is_array( $this->sectionids ) ) {
			$this->sectionids = array( $this->sectionids );
		}
		
		JArrayHelper::toInteger( $this->sectionids, array(0) );
		
		if ( $this->catids && !is_array( $this->catids ) ) {
			$this->catids = array( $this->catids );
		}
		
		JArrayHelper::toInteger( $this->catids, array(0) );
		
		$this->display_mode		= $params->get('display_mode');
		
		// Parameters from articles
		$this->ordering		 	= $params->get('ordering');
		$this->column			= intval( $params->get( 'columns', 1 ) );
		$this->intro			= intval( $params->get( 'intro', 0 ) );
		$this->leading			= intval( $params->get( 'leading', 1 ) );
		$this->links			= intval( $params->get( 'links', 0 ) );
		$this->access_mode		= $params->get( 'access_mode' );
		$this->allnews 			= $params->get( 'allnews' );
		$this->usefront			= intval( $params->get( 'usefront', 0 ) );
		
		// Details
		$this->show_title		= intval( $params->get( 'show_title', 1 ) );
		$this->link_title		= intval( $params->get( 'link_title', 1 ) );
		$this->show_cat	 		= intval( $params->get( 'show_cat', 1 ) );
		$this->catlink			= intval( $params->get( 'catlink', 0 ) );
		$this->show_author		= intval( $params->get( 'show_author', 1 ) );
		$this->show_intro		= intval( $params->get( 'show_intro', 1 ) );
		$this->intro_length		= intval( trim( $params->get( 'intro_length', 150 ) ) );
		$this->show_readmore	= intval( $params->get( 'show_readmore', 1 ) );
		$this->open_mode		= $params->get( 'open_mode' );
		
		// Parameters from date
		$this->show_date	 	= intval($params->get('show_date', 1));
		$this->formatdate		= modNeoLatestNewsHelper::_convertFormatDate($params->get('formatdate'));
		
		// Parameters from images
		$this->show_images 		= intval($params->get('show_images', 1));
		$this->images_size		= intval($params->get('images_size', 0));
		$this->images_position	= $params->get('images_position');
		$this->images_maxwidth 	= intval(trim($params->get('images_maxwidth', 50)));
		$this->images_maxheight = intval(trim($params->get('images_maxheight', 50)));
		
		$this->show_seperator	= intval($params->get('show_seperator', 0));
	}



	function getDatas() {
		
		global $mainframe;
		
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		
		$now 		= date( 'Y-m-d H:i', time() );
		$access 	= !$mainframe->getCfg( 'shownoauth' );
		$nullDate 	= $db->getNullDate();		
		$count 		= ( $this->intro + $this->leading + $this->links );
		
		$query = " SELECT a.id, a.title, a.sectionid, a.catid, a.created, a.introtext, a.fulltext, a.images, cc.title AS catname, u.name AS author, u.username as author_alias, a.access "
		. "\n FROM #__content AS a "	
		. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id "
		. "\n INNER JOIN #__categories AS cc ON cc.id = a.catid "
		. "\n INNER JOIN #__sections AS s ON s.id = a.sectionid "
		. "\n INNER JOIN #__users AS u ON u.id = a.created_by "
		. "\n WHERE ( a.state = 1 ) "
		. "\n AND ( a.publish_up = '$nullDate' OR a.publish_up <= '$now' ) "
		. "\n AND ( a.publish_down = '$nullDate' OR a.publish_down >= '$now' ) "
		. ( $access && $this->access_mode == 'hide' ? "\n AND a.access <= $user->gid AND cc.access <= $user->gid AND s.access <= $user->gid " : '' )
		. ( $this->content_source == 'sections' && count( $this->sectionids ) ? "\n AND ( a.sectionid IN ( " . implode( ',', $this->sectionids ) . " ) ) " : '' )
		. ( $this->content_source == 'categories' && count( $this->catids ) ? "\n AND ( a.catid IN ( " . implode( ',', $this->catids ) . " ) ) " : '' )
		. ( $this->usefront == 0 ? "\n AND f.content_id IS NULL" : '' )
		. "\n AND s.published = 1 "
		. "\n AND cc.published = 1 ";
		
		switch( $this->ordering ) {
			case "date" : 	$query .= "\n ORDER BY a.created DESC"; 	break;
			case "rdate" : 	$query .= "\n ORDER BY a.created ASC"; 		break;
			case "alpha" : 	$query .= "\n ORDER BY a.title ASC"; 		break;
			case "ralpha" : $query .= "\n ORDER BY a.title DESC"; 		break;
			case "order" : 	$query .= "\n ORDER BY a.ordering ASC"; 	break;
		}
		$query .= ($this->ordering != 'random') ? "\n LIMIT $count" : ''; // Don't use limit for random ordering
		
		$db->setQuery( $query );
		$rows = $db->loadObjectList();
		
		return $rows;
	}



	// Display title item	
	function displayTitle( $row ) {
		
		$c = '';
		$onclick 	= '';
		$target 	= 'target="'. ( $this->open_mode == 'pop' ? '_blank' : '_self' ) .'"';
		$link 		= modNeoLatestNewsHelper::_getLinkURL( $row );
		$locked 	= ( $this->access_mode == 'lock' && $row->access == 1 ) ? '<span class="locked">'. JText::_( 'Locked' ) .'</span> ' : '';
		
		if ( $this->content_source == 'rss' ) {
			$title 	= utf8_encode( $row->title );
		} else {
			$title = $row->title;
		}
		
		// Title
		if ( $this->display_mode == 'accordion' ) {
			$c = '<h4 class="newstitle toogler atStart">'
			. $locked . $title .'</h4>';
			
		} elseif ( $this->show_title ) {
			
			if ( $this->link_title ) {
				$c = '<h4 class="newstitle">'
				.'<a href="'. $link .'" '. $target .' title="'. $title .'" class="newstitle">'. $locked . $title .'</a>'
				.'</h4>';
			} else { 
				$c = '<h4 class="newstitle"><span class="newstitle">'. $locked . $title .'</span></h4>';
			}
		}
		
		return $c;
	}
	
	
	// Display varies infos about item (date, author...)	
	function displayArticleInfos( &$row ) {
		
		global $mainframe;
		
		$rcatname 	= modNeoLatestNewsHelper::_selectDataSource( $row, 'catname', 'category' );
		$rcreated 	= modNeoLatestNewsHelper::_selectDataSource( $row, 'created', 'pubDate' );
		
		$c = '<div class="article-tools">';
		
		// Category
		if ( $this->show_cat && $rcatname != '' ) {
			
			if ( $this->catlink ) {
				$link 	= ContentHelperRoute::getCategoryRoute( $row->catid, $row->sectionid );
				$rcatname = '<a href="'. $link .'" title="'. $rcatname .'">'. $rcatname .'</a>';
			}
			
			$c .= '<div class="category">' . $rcatname .'</div> ';
		}
		
		// Author
		if ( $this->show_author && $row->author != '' ) {
			$c .= '<span class="small createby">'. JText::_( 'written by' ). ' ' . ( $row->author_alias ? $row->author_alias : $row->author ) .'</span> ';
		}
		
		// Date
		if( $this->show_date ) {
			$c .= '<span class="small createdate">'. JHTML::_( 'date', $rcreated, $this->formatdate ) .'</span>';
		}
		
		$c = $c . '</div>';
		
		return $c;	
	}
	
	
	
	// Display first image contained on text
	function getImage( &$row ) {
		
		$image_url 	= '';
		$is_image 	= isset( $row->images ) ? 1 : 0;
		
		$rtext = modNeoLatestNewsHelper::_selectDataSource( $row, 'introtext', 'description' );
		
		if ( $this->show_images ) {
			
			preg_match("'<img(| .*?)/>'", $rtext, $output);
			if ( count($output) > 1 ) {
				preg_match('#src="(.*?)"#', $output[1], $image);
				$image_url = $image[1];
			}
		}
		
		return $image_url;
	}
	
	
	// Formatting the image tag
	function displayImage ( $image_url, $image_title='' ) {
		
		$image_title	= $image_title != '' ? $image_title : ($image_url ? substr(strrchr( $image_url, '/'), 1) : '');
		$image_position	= ''; 
		
		//Define alignment for image
		if( $this->images_position != 'top' || $this->images_position != 'column' ) {
			switch( $this->images_position ) {
				case 'left': 			$margin = '0.1em 1em 0.1em 0'; break;
				case 'right': 			$margin = '0.1em 0 0.1em 1em'; break;
				case 'default':default: $margin = '0.2em'; break;
			}
			$image_position = 'align="'. $this->images_position .'" style="margin:'. $margin .'"';
		}
		
		$c = '';
		$ratio = 1;
		
		if ( $image_url ) {
			
			// Resize
			if ( $this->images_size == 1 ) {
				
				list( $width, $height ) = @getimagesize( $image_url );
				
				$minsize = min( $width, $height );
				$maxsize = max( $width, $height );
				
				if( $width > $this->images_maxwidth || $height > $this->images_maxheight ) {				
					$ratio = ($height <=  $width) ? ( $this->images_maxheight / $width ) : ( $this->images_maxwidth / $height );
				}
				$new_width 	= round( $width * $ratio );
				$new_height = round( $height * $ratio );
				
				$c = '<div class="newsimage">'
				.'<img src="'. $image_url .'" border="0" width="'.$new_width.'" height="'.$new_height.'" '.$image_position.' alt="'.$image_title.'" title="'.$image_title.'" />'
				.'</div>';
				
			// Original size
			} else {
				$c = '<div class="newsimage">'
				.'<img src="'. $image_url .'" border="0" '.$image_position.' alt="'.$image_title.'" />'
				.'</div>';
			}
		}
		
		return $c;
	}
	
	
	
	// Display intro text of item, truncate or not
	function displayIntro( &$row ) {
		
		$rtext = modNeoLatestNewsHelper::_selectDataSource( $row, 'introtext', 'description' );	
		
		$c = '';
		$rtext = str_replace('{mosimage}', '', $rtext);		
		
		// Show introtext with x chars. only
		if( $this->show_intro == 2 && $this->intro_length > 0 ) {	
			$c 	= '<div class="newstext">'. modNeoLatestNewsHelper::_splitText($rtext, $this->intro_length) .'</div>';
		
		// Show full introtext
		}elseif( $this->show_intro == 1 ) {
			$c 	= '<div class="newstext">'. ( $this->images_position != 'default' ? @ereg_replace('<img+[^<>]+>+', '', $rtext) : $rtext ) .'</div>';
		}
		
		return $c;		
	}
	
	
	
	// Display link to read full text of item	
	function displayReadmore( $row ) {
		
		$c = '';
		$onclick 	= '';
		$target 	= 'target="'. ( $this->open_mode == 'pop' || $this->content_source == 'rss' ? '_blank' : '_self' ) .'"'; 		
		$link 		= modNeoLatestNewsHelper::_getLinkURL( $row );
		
		$rtext 		= modNeoLatestNewsHelper::_selectDataSource( $row, 'introtext', 'description' );	
		$display 	= strlen( $rtext ) > 5 || strlen( $rtext ) > $this->intro_length ? 1 : 0;
		
		// Link readmore
		if ( $display == 1 && $this->show_readmore ) {
			echo '<div class="readmore">
			<a href="'. $link .'" '.$target.' title="'. $row->title .'" class="readon">'. JText::sprintf( 'Read more...' ) .'</a></div>';
		}
		return $c;
	}
	
	
	// Display seperator between each article	
	function displaySeperator() {
		$c = ( $this->show_seperator ) ? '<span class="separator article_separator"> </span>' : '';
		return $c;
	}
	
	
	function displayReadall( &$row ) {
		
		$db =& JFactory::getDBO();
		
		$c = '';
		$links = array();
		$ids = array();
		
		if ( $this->allnews && ( $this->content_source == 'sections' || $this->content_source == 'categories') ) {
			
			switch( $this->content_source ) {
				
				case 'sections' :	
					$ids = $this->sectionids;				
				break;
				
				case 'categories' : 	
					$ids = $this->catids;
				break;
			}
			
			foreach( $ids as $id ) {
				
				$link = null;				
				switch( $this->content_source ) {
					
					case 'sections' :						
						$query = " SELECT title "
						. "\n FROM #__sections "
						. "\n WHERE id = $id ";
						$db->setQuery( $query );
						$obj = $db->loadObject();
						$link 	= ContentHelperRoute::getSectionRoute( $id );
					break;
					
					case 'categories' :
						// TODO : get sectionid for each category ID 
						$query = " SELECT title, section "
						. "\n FROM #__categories "
						. "\n WHERE id = $id ";
						$db->setQuery( $query );
						$obj = $db->loadObject();
						$link 	= ContentHelperRoute::getCategoryRoute( $id, $obj->section );
					break;
				}
				
				if ( !is_null( $link ) ) {
					$links[] = '<a href="'. $link .'" title="'. $obj->title .'">'. $obj->title .'</a>';
				}
			}
			
			$c = '<div class="readall"><span>'.JText::_( 'All articles' ).' : </span>'.implode( ' | ', $links ).'</div>';
		}
		
		return $c;
	}
	
	
	// Return count of row items, by default or randomly
	function getCountLimit( &$rows ) {
		$count = $this->ordering == 'random' ? ( $this->intro + $this->leading + $this->links ) : count( $rows );
		return $count;
	}
	
	
	// Reorder randomly list of items
	function getRandomItems( &$rows, $count ) {
		$this->rand_items = $this->ordering == 'random' ? @array_rand($rows, $count) : NULL;
		return $this->rand_items;
	}
	
	
	// Init total of column and reduce it if count is too less
	function getColumnNumber( $count ) {
		
		$cols 	= $this->column == 0 ? 1 : $this->column;
		$total 	= ( $count - $this->leading - $this->links );
		
		$this->column = ( $cols > 1 && $cols > $total ) ? $total : $cols; 
		
		return $this->column;
	}
	
	
	// Return row randomly or ordered
	function sortItem( $i, $rows ) {
		$row = ( $this->ordering == 'random' ) ? $rows[ ( is_array( $this->rand_items ) ? $this->rand_items[$i] : $this->rand_items ) ] : $rows[$i];
		return $row;
	}
	
	
	/* **** Private methods  **** */
	
	function _splitText( $text, $limit ) {		
		$text 	= strip_tags($text); // Clean html tags
		
		if ( strlen($text) > $limit ) {
			$text 	= substr($text, 0, $limit);			
			$nlimit = strrpos($text, ' ');	// Detect last SPACE char.
			$text 	= substr($text, 0, $nlimit)."&hellip;" ;
		}
		return $text;
	}


	//Formatage utilisé par la fonction mosFormatDate() : %Y-%m-%d %H:%M:%S
	function _convertFormatDate( $formatdate='' ) {
		
		if( $formatdate == '' ) { 
			$formatdate = "dd/mm/yy H:M";
		}
		$m 	= array('dd', 'mm', 'yy', 'H', 'M', 'S');
		$r 	= array('%d', '%m', '%Y', '%H', '%M', '%S');
		
		$formatdate = str_replace($m, $r, $formatdate);
		
		return $formatdate;
	}
	
	
	// Get url type and url path to item	
	function _getLinkURL ( $row ) {
		
		if ( $this->content_source == 'rss' ) {
			
			$link = $row->link;
			
		} else {
			
			$link = ContentHelperRoute::getArticleRoute( $row->id, $row->catid, $row->sectionid );
			
			switch ( $this->open_mode ) {
				
				case 'pop' : 
					$link .= '&amp;tmpl=component';
					$link  = "#\" onclick=\"window.open('". JRoute::_( $link ) ."', 'win2', 'status=no, toolbar=no, scrollbars=yes, titlebar=no, menubar=no,resizable=yes, width=640, height=480, directories=no, location=no'); return false;\"";
				break;
				
				case 'self' : 
				default : 
					$link = JRoute::_( $link );
				break;
			}
		}
		
		return $link;	
	}
	
	
	// Get source of content "article" or "RSS"
	function _selectDataSource( $row, $dbAttribute, $rssAttribute ) {
		
		if ( $this->content_source == 'rss' ) {
			if ( isset( $row->$rssAttribute ) ) return $row->$rssAttribute;
		} else {			
			if ( isset( $row->$dbAttribute ) ) return $row->$dbAttribute;
		}
		
		return '';
	}	
}
?>