<?php
/**
* @package NeoLatestNews
* @copyright Copyright (C) 2004 - 2009 Neoweb. All rights reserved.
* @license GNU/GPL
* @version 1.4.1
* @author NeoJoomla
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$db =& JFactory::getDBO();
$user =& JFactory::getUser();

require_once( JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php' );
require_once( JPATH_SITE.DS.'modules'.DS.'mod_neolatestnews'.DS.'helper.php' );

$moduleid			= intval($module->id);
$moduleclass_sfx 	= $params->get('moduleclass_sfx');
$listclass_sfx 		= $params->get('listclass_sfx');
$display_mode		= $params->get('display_mode');
$content_source		= $params->get('content_source');
$rss_url		 	= $params->get('rss_url');

$sectionid 			= intval($params->get('sectionid'), 0);
$catid 			 	= intval($params->get('catid'), 0);
$usefront			= intval($params->get('usefront'), 0);
$ordering		 	= $params->get('ordering');
$leading			= intval($params->get('leading', 0));
$cols				= intval($params->get('columns', 1));
$intro 				= intval($params->get('intro', 5));
$links				= intval($params->get('links', 0));
$images_position	= $params->get('images_position');
$access_mode		= $params->get('access_mode');

$scroll_width		= intval( $params->get( 'scroll_width', 200 ) );
$scroll_height		= intval( $params->get( 'scroll_height', 300 ) );
$scroll_padding		= intval( $params->get( 'scroll_padding', 10 ) );

modNeoLatestNewsHelper::init( $params );

$rows = modNeoLatestNewsHelper::getDatas();

$nbRows = count( $rows );

if ( $leading > $nbRows ) 							$leading = $nbRows;
if ( ( $leading + $intro ) > $nbRows ) 				$intro = $nbRows - $leading;
if ( ( $leading + $intro + $links ) > $nbRows ) 	$links = $nbRows - $leading - $intro;

if ( $content_source == 'rss' ) {	
	
	// Get content items from RSS url	
	require_once( JPATH_SITE.DS.'modules'.DS.'mod_neolatestnews'.DS.'readrssfeed.class.php' );
	$xml  = new neolatestnews_readRSSfeed( intval( ( $intro + $leading + $links ) ) );
	$rows = $xml->readRSS( $rss_url );
}

// get number of article items to show
$count 		= modNeoLatestNewsHelper::getCountLimit( $rows );
$randItems	= modNeoLatestNewsHelper::getRandomItems( $rows, $count );

$mainframe->addCustomHeadTag( '<link rel="stylesheet" type="text/css" href="'.JURI::Base().'modules'.DS.'mod_neolatestnews'.DS.'css'.DS.'neolatestnews.css" />' );
?>
	
<!--begin:neolatestnews-->
<div class="neolatestnews<?php echo $listclass_sfx; ?>">

	<?php if ( $count > 0 ) {
		
		switch( $display_mode ) {
			
			case 'accordion' : 
				include( JPATH_SITE.DS.'modules'.DS.'mod_neolatestnews'.DS.'tmpl'.DS.'accordion.html.php');
			break;
			
			case 'hscroll' : 
				include( JPATH_SITE.DS.'modules'.DS.'mod_neolatestnews'.DS.'tmpl'.DS.'hscroll.html.php');
			break;
			
			case 'vscroll' : 
				include( JPATH_SITE.DS.'modules'.DS.'mod_neolatestnews'.DS.'tmpl'.DS.'vscroll.html.php');
			break;
			
			default : 		
				include( JPATH_SITE.DS.'modules'.DS.'mod_neolatestnews'.DS.'tmpl'.DS.'default.html.php');
			break;
		}
		
	} else { 
		echo '<p align="center">'.JText::_( 'No data' ).'</p>';
	}
	?>
</div>
<!--end:neolatestnews-->