<?php
/**
* @package NeoLatestNews
* @copyright Copyright (C) 2004 - 2009 Neoweb. All rights reserved.
* @license GNU/GPL
* @version 1.4.1
* @author NeoJoomla
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );


class neolatestnews_readRSSfeed {

	/* **** Private vars  **** */
	var $itemslimit	= 50;
	var $dateformat	= 'Y-m-d';	
	var $hourformat	= 'H:M:S';
	var $itemtags 	= array('title', 'link', 'author', 'comments', 'enclosure', 'pubDate', 'dc:creator', 'description', 'media:content', 'media:title');
	var $imagetags 	= array('title', 'url', 'link', 'description', 'width', 'height');
	
	
	function neolatestnews_readRSSfeed( $count=1 ) {
		
		$this->itemslimit = intval( $count );
	}	


	/* **** Public methods  **** */
	
	function readRSS ( $rss_url='' ) {
		
		$rss_output = NULL;
		
		// Load & read rss file
		if ( $f = @fopen( $rss_url, 'r' ) ) {
			
			$rss_content = '';
			while (!feof($f)) {
				$rss_content .= fgets($f, 4096);
			}
			fclose($f);

			
			// Read each <item> tags
			preg_match_all("'<item(| .*?)>(.*?)</item>'si", $rss_content, $items);
			
			$rss_items 	= $items[2];			
			$rss_output = array();
			$i = 0;
			
			foreach( $rss_items as $rss_item ) {
				
				// Limit number of items if it is lower  or very high
				if ($i < $this->itemslimit || $this->itemslimit == 0) {
					
					$d = (object) NULL;
					
					foreach( $this->itemtags as $itemtag ) {
						
						$tmp = $this->clearCDATA( "'<$itemtag.*?>(.*?)</$itemtag>'si", $rss_item );				
						if ( $tmp != '' ) $d->{ $itemtag } = $tmp;
						
						// Get image url from ENCLOSURE
						$tmp_img = $this->getAttributeValue( "'<$itemtag(| .*?)>(.*?)</$itemtag>'si", 'url', $rss_item );
						if ( $tmp_img != '' ) $d->{$itemtag} = $tmp_img;
					}
					
					// Strip HTML tags from TITLE
					if ( $d->title ) {
						$d->title = strip_tags( utf8_decode($d->title) );
					}
					
					//  Convert date format from PUBDATE
					if ( $d->pubDate ) {
						$d->pubDate = $this->convertDate( $d->pubDate );
					}
					
					$rss_output[$i] = $d; 
					
					$i++;
				}
			}
		}
		
		return $rss_output;
	}

	
	
	/* **** Private methods  **** */	
	
	function clearCDATA ( $pattern, $handle ) {
		
		// start regular expression
		preg_match($pattern, $handle, $output);
		
		$result = false;
		if( isset($output[1]) ) {
			// get CDATA content without CDATA tag
			$output[1] = strtr($output[1], array('<![CDATA['=>'', ']]>'=>''));
			$result = trim($output[1]);
		}
		
		return $result;
	}
	
	
	function getAttributeValue( $pattern, $attribute, $handle ) {
		
		preg_match( $pattern, $handle, $output );
		
		$result = '';
		
		if ( isset( $output[1] ) ) {
			preg_match( '#'.$attribute.'="(.*?)"#', $output[1], $output_item );
			if ( array_key_exists( 1, $output_item ) ) {
				$result = trim( $output_item[1] );
			}
		}
		
		return $result;
	}
	
	
	
	function convertDate ( $date ) {
		
		$timestamp = strtotime( $date );
		$hourstamp = substr($date, 16, 9);
		
		$result = date($this->dateformat, $timestamp).' '.$hourstamp;		
		//echo '<h4>'.$date.' --> '.$timestamp.' --> '.$rs.'</h4>';
		return $result;
	}
}
?>